/* Do not edit: automatically built by dist/distrib. */
/*-
 * See the file LICENSE for redistribution information.
 *
 * Copyright (c) 1996, 1997
 *	Sleepycat Software.  All rights reserved.
 *
 *	@(#)db.h.src	10.19 (Sleepycat) 6/12/97
 */

#ifndef _DB_H_
#define	_DB_H_

#ifndef __NO_SYSTEM_INCLUDES
#include <sys/types.h>

#include <stdio.h>
#endif

/*
 * XXX
 * MacOS: ensure that Metrowerks C makes enumeration types int sized.
 */
#ifdef __MWERKS__
#pragma enumsalwaysint on
#endif

/*
 * XXX
 * Handle function prototypes and the keyword "const".  This steps on name
 * space that DB doesn't control, but all of the other solutions are worse.
 */
#undef	__P
#if defined(__STDC__) || defined(__cplusplus)
#define	__P(protos)	protos		/* ANSI C prototypes */
#else
#define	const
#define	__P(protos)	()		/* K&R C preprocessor */
#endif

/*
 * !!!
 * DB needs basic information about specifically sized types.  If they're
 * not provided by the system, typedef them here.
 *
 * We protect them against multiple inclusion using __BIT_TYPES_DEFINED__,
 * as does BIND and Kerberos, since we don't know for sure what #include
 * files the user is using.
 */
#ifndef	__BIT_TYPES_DEFINED__
#define	__BIT_TYPES_DEFINED__
typedef unsigned char u_int8_t;
typedef short int16_t;
typedef unsigned short u_int16_t;
typedef int int32_t;
typedef unsigned int u_int32_t;
#endif

#define	DB_VERSION_MAJOR	2
#define	DB_VERSION_MINOR	1
#define	DB_VERSION_PATCH	0
#define	DB_VERSION_STRING	"Sleepycat Software: DB 2.1.0: (6/13/97)"

typedef	u_int32_t	db_pgno_t;	/* Page number type. */
typedef	u_int16_t	db_indx_t;	/* Page offset type. */
#define	DB_MAX_PAGES	0xffffffff	/* >= # of pages in a file */

typedef	u_int32_t	db_recno_t;	/* Record number type. */
typedef size_t		DB_LOCK;	/* Object returned by lock manager. */
#define	DB_MAX_RECORDS	0xffffffff	/* >= # of records in a tree */

/* Forward structure declarations, so applications get type checking. */
struct __db;		typedef struct __db DB;
#ifdef DB_DBM_HSEARCH
			typedef struct __db DBM;
#endif
struct __db_dbt;	typedef struct __db_dbt DBT;
struct __db_env;	typedef struct __db_env DB_ENV;
struct __db_info;	typedef struct __db_info DB_INFO;
struct __db_lockregion;	typedef struct __db_lockregion DB_LOCKREGION;
struct __db_lockreq;	typedef struct __db_lockreq DB_LOCKREQ;
struct __db_locktab;	typedef struct __db_locktab DB_LOCKTAB;
struct __db_log;	typedef struct __db_log DB_LOG;
struct __db_lsn;	typedef struct __db_lsn DB_LSN;
struct __db_mpool;	typedef struct __db_mpool DB_MPOOL;
struct __db_mpool_fstat;typedef struct __db_mpool_fstat DB_MPOOL_FSTAT;
struct __db_mpool_stat;	typedef struct __db_mpool_stat DB_MPOOL_STAT;
struct __db_mpoolfile;	typedef struct __db_mpoolfile DB_MPOOLFILE;
struct __db_txn;	typedef struct __db_txn DB_TXN;
struct __db_txnmgr;	typedef struct __db_txnmgr DB_TXNMGR;
struct __db_txnregion;	typedef struct __db_txnregion DB_TXNREGION;
struct __dbc;		typedef struct __dbc DBC;

/* Key/data structure -- a Data-Base Thang. */
struct __db_dbt {
	void	 *data;			/* key/data */
	u_int32_t size;			/* key/data length */
	u_int32_t ulen;			/* RO: length of user buffer. */
	u_int32_t dlen;			/* RO: get/put record length. */
	u_int32_t doff;			/* RO: get/put record offset. */

#define	DB_DBT_MALLOC	0x01		/* Return in allocated memory. */
#define	DB_DBT_USERMEM	0x02		/* Return in user's memory. */
#define	DB_DBT_PARTIAL	0x04		/* Partial put/get. */
#define	DB_DBT_INTERNAL	0x08		/* Perform any mallocs using regular
					   malloc, not the user's malloc. */
	u_int32_t flags;
};

/*
 * Database configuration and initialization.
 *
 * Flags to specify how files are opened/created throughout DB.  The flags
 * DB_EXCL, DB_MUTEXDEBUG and DB_TEMPORARY are only used internally, and so
 * aren't documented.
 */
#define	DB_CREATE		0x001	/* O_CREAT: create. */
#define	DB_EXCL			0x002	/* O_EXCL: exclusive open. */
#define	DB_MUTEXDEBUG		0x004	/* Do not get/set mutexes in regions. */
#define	DB_NOMMAP		0x008	/* Don't mmap the file. */
#define	DB_RDONLY		0x010	/* O_RDONLY: read-only. */
#define	DB_SEQUENTIAL		0x020	/* Indicate sequential access. */
#define	DB_TEMPORARY		0x040	/* Remove on last close. */
#define	DB_TRUNCATE		0x080	/* O_TRUNCATE: replace existing DB. */

/* Flags to db_appinit(). */
/*				0x001	   DB_CREATE is used by db_appinit(). */
#define	DB_INIT_LOCK		0x002	/* Initialize locking. */
#define	DB_INIT_LOG		0x004	/* Initialize logging. */
#define	DB_INIT_MPOOL		0x008	/* Initialize mpool. */
#define	DB_INIT_TXN		0x010	/* Initialize transactions. */
#define	DB_USE_ENVIRON		0x020	/* Use the environment. */
#define	DB_USE_ENVIRON_ROOT	0x040	/* Use the environment if root. */

struct __db_env {
	int		 db_lorder;	/* Byte order. */

	/* Error information. */
	char		*db_errbuf;	/* Error message buffer. */
	FILE		*db_errfile;	/* Error message file stream. */
	const char	*db_errpfx;	/* Error message prefix. */

	/* User paths. */
	char		*db_home;	/* Database home. */
	char		*db_data_dir;	/* Database data file directory. */
	char		*db_log_dir;	/* Database log file directory */
	char		*db_tmp_dir;	/* Database tmp file directory. */

	/* Locking. */
	DB_LOCKTAB	*lk_info;	/* Return from lock_open(). */
	u_int8_t	*lk_conflicts;	/* Two dimensional conflict matrix. */
	int		 lk_modes;	/* Number of lock modes in table. */
	unsigned int	 lk_max;	/* Maximum number of locks. */

	/* Logging. */
	DB_LOG		*lg_info;	/* Return from log_open(). */
	u_int32_t	 lg_max;	/* Maximum file size. */

	/* Memory pool. */
	DB_MPOOL	*mp_info;	/* Return from memp_open(). */
	size_t		 mp_mmapsize;	/* Maximum file size for mmap. */
	size_t		 mp_size;	/* Bytes in the mpool cache. */

	/* Transactions. */
	DB_TXNMGR	*tx_info;	/* Return from txn_open(). */
	unsigned int	 tx_max;	/* Maximum number of transactions. */
	int (*tx_recover)		/* Dispatch function for recovery. */
	    __P((DB_LOG *, DBT *, DB_LSN *, int, void *));

	/* Currently unused lock flags. */
#define	DB_TXN_LOCK_2PL		0x0000	/* Two-phase locking. */
#define	DB_TXN_LOCK_OPTIMISTIC	0x0000	/* Optimistic locking. */
#define	DB_TXN_LOCK_MASK	0x0000	/* Lock flags mask. */

	/* Currently unused log flags. */
#define	DB_TXN_LOG_REDO		0x0000	/* Redo-only logging. */
#define	DB_TXN_LOG_UNDO		0x0000	/* Undo-only logging. */
#define	DB_TXN_LOG_UNDOREDO	0x0000	/* Undo/redo write-ahead logging. */
#define	DB_TXN_LOG_MASK		0x0000	/* Log flags mask. */

	/* Flags. */
#define	DB_APP_INIT		0x0001	/* Appinit called, paths initialized. */
#define	DB_MPOOL_PRIVATE	0x0004	/* Mpool: private memory pool. */

	u_int32_t	 flags;
};

/*******************************************************
 * Access methods.
 *******************************************************/
typedef enum {
	DB_BTREE=1,			/* B+tree. */
	DB_HASH,			/* Extended Linear Hashing. */
	DB_RECNO,			/* Fixed and variable-length records. */
	DB_UNKNOWN			/* Figure it out on open. */
} DBTYPE;

struct __db_info {
	int		 db_lorder;	/* Byte order. */
	size_t		 db_cachesize;	/* Underlying cache size. */
	size_t		 db_pagesize;	/* Underlying page size. */

					/* Local heap allocation. */
	void *(*db_malloc) __P((size_t));

	/* Btree access method. */
	int		 bt_maxkey;	/* Maximum keys per page. */
	int		 bt_minkey;	/* Minimum keys per page. */
	int (*bt_compare)		/* Comparison function. */
	    __P((const DBT *, const DBT *));
	size_t (*bt_prefix)		/* Prefix function. */
	    __P((const DBT *, const DBT *));

	/* Hash access method. */
	unsigned int	 h_ffactor;	/* Fill factor. */
	unsigned int	 h_nelem;	/* Number of elements. */
	u_int32_t	(*h_hash)	/* Hash function. */
	    __P((const void *, u_int32_t));

	/* Recno access method. */
	int		 re_pad;	/* Fixed-length padding byte. */
	int		 re_delim;	/* Variable-length delimiting byte. */
	u_int32_t	 re_len;	/* Length for fixed-length records. */
	char		*re_source;	/* Source file name. */

#define	DB_DELIMITER		0x0001	/* Recno: re_delim set. */
#define	DB_DUP			0x0002	/* Btree, Hash: duplicate keys. */
#define	DB_FIXEDLEN		0x0004	/* Recno: fixed-length records. */
#define	DB_PAD			0x0008	/* Recno: re_pad set. */
#define	DB_SNAPSHOT		0x0010	/* Recno: snapshot the input. */
	u_int32_t	 flags;
};

/*
 * DB access method and cursor operation codes.  These are implemented as
 * bit fields for future flexibility, but currently only a single one may
 * be specified to any function.
 */
#define	DB_AFTER	0x00001		/* c_put() */
#define	DB_BEFORE	0x00002		/* c_put() */
#define	DB_CHECKPOINT	0x00004		/* log_put(), log_get() */
#define	DB_CURRENT	0x00008		/* c_get(), c_put(), log_get() */
#define	DB_FIRST	0x00010		/* c_get(), log_get() */
#define	DB_FLUSH	0x00020		/* log_put() */
#define	DB_KEYFIRST	0x00040		/* c_put() */
#define	DB_KEYLAST	0x00080		/* c_put() */
#define	DB_LAST		0x00100		/* c_get(), log_get() */
#define	DB_NEXT		0x00200		/* c_get(), log_get() */
#define	DB_NOOVERWRITE	0x00400		/* put() */
#define	DB_NORECURSE	0x00800		/* log_put() */
#define	DB_NOSYNC	0x01000		/* close() */
#define	DB_PREV		0x02000		/* c_get(), log_get() */
#define	DB_SET		0x04000		/* c_get(), log_get() */
#define	DB_SET_RANGE	0x08000		/* c_get() */

/* DB (user visible) error return codes. */
#define	DB_INCOMPLETE		-1	/* Sync didn't finish. */
#define	DB_KEYEXIST		-1	/* The key/data pair already exists. */
#define	DB_LOCK_DEADLOCK	-1	/* Locker killed to resolve deadlock. */
#define	DB_LOCK_NOTGRANTED	-2	/* Lock unavailable, no-wait set. */
#define	DB_LOCK_NOTHELD		-3	/* Lock not held by locker. */
#define	DB_NOTFOUND		-1	/* We didn't find whatever it was. */

/* DB (private) error return codes. */
#define	DB_DELETED		-1	/* Recovery file marked deleted. */
#define	DB_NEEDSPLIT		-1	/* Page needs to be split. */
#define	DB_REGISTERED		-1	/* Entry was previously registered. */
#define	DB_SWAPBYTES		-1	/* Database needs byte swapping. */

struct __db_ilock {			/* Internal DB access method lock. */
	db_pgno_t	pgno;		/* Page being locked. */
	u_int8_t	fileid[1];	/* Variable length file id. */
};

/* DB access method description structure. */
struct __db {
	DBTYPE	 type;			/* DB access method. */
	DB_ENV	*dbenv;			/* DB_ENV structure. */
	DB_ENV	*mp_dbenv;		/* DB_ENV for local mpool creation. */

	void	*internal;		/* Access method private. */

	DB_MPOOL	*mp;		/* The access method's mpool. */
	DB_MPOOLFILE	*mpf;		/* The access method's mpool file. */

	u_int32_t log_fileid;		/* Logging file id. */

	DB_TXN	 *txn;			/* Current transaction. */
	u_int32_t locker;		/* Default process' locker id. */
	DBT	  lock_dbt;		/* DBT referencing lock. */
	struct __db_ilock *lock;	/* Lock. */

	size_t	  pgsize;		/* Logical page size of file. */

					/* Local heap allocation. */
	void *(*db_malloc) __P((size_t));

					/* Functions. */
	int (*close)	__P((DB *, int));
	int (*cursor)	__P((DB *, DB_TXN *, DBC **));
	int (*del)	__P((DB *, DB_TXN *, DBT *, int));
	int (*fd)	__P((DB *, int *));
	int (*get)	__P((DB *, DB_TXN *, DBT *, DBT *, int));
	int (*put)	__P((DB *, DB_TXN *, DBT *, DBT *, int));
	int (*stat)	__P((DB *, FILE *));
	int (*sync)	__P((DB *, int));

#define	DB_AM_DUP	0x000001	/* Duplicate keys. */
#define	DB_AM_INMEM	0x000002	/* In-memory; no sync on close. */
#define	DB_AM_LOCKING	0x000004	/* Perform locking. */
#define	DB_AM_LOGGING	0x000008	/* Perform logging. */
#define	DB_AM_MLOCAL	0x000010	/* Database memory pool is local. */
#define	DB_AM_PGDEF	0x000020	/* Page size was defaulted. */
#define	DB_AM_RDONLY	0x000040	/* Database is readonly. */
#define	DB_AM_RECOVER	0x000080	/* In recovery (do not log or lock). */
#define	DB_AM_SWAP	0x000100	/* Pages need to be byte-swapped. */
#define	DB_AM_TXN	0x000200	/* Use transaction protection. */
#define	DB_BT_DELIMITER	0x000400	/* Delimiter field is set. */
#define	DB_BT_EOF	0x000800	/* End of input source file reached. */
#define	DB_BT_FIXEDLEN	0x001000	/* Fixed length records. */
#define	DB_BT_PAD	0x002000	/* Pad field is set. */
#define	DB_BT_SNAPSHOT	0x004000	/* Snapshot the source file. */
#define	DB_HS_DIRTYMETA 0x008000	/* Metadata page has been modified. */
#define	DB_RE_MODIFIED	0x010000	/* Tree is modified. */
	u_int32_t flags;
};

/* Cursor description structure. */
struct __dbc {
	const DB *dbp;			/* Related DB access method. */
	DB_TXN	 *txn;			/* Associated transaction. */

	void	 *internal;		/* Access method private. */

	int (*c_close)	__P((DBC *));
	int (*c_del)	__P((DBC *, int));
	int (*c_get)	__P((DBC *, DBT *, DBT *, int));
	int (*c_put)	__P((DBC *, DBT *, DBT *, int));
};

#define	DB_BTREEVERSION	5
#define	DB_BTREEMAGIC	0x053162

#define	DB_HASHVERSION	4
#define	DB_HASHMAGIC	0x061561

#define	DB_LOGVERSION	2
#define	DB_LOGMAGIC	0x040988

#if defined(__cplusplus)
extern "C" {
#endif
int   db_appinit __P((const char *, char * const *, DB_ENV *, int));
int   db_appexit __P((DB_ENV *));
int   db_open __P((const char *, DBTYPE, int, int, DB_ENV *, DB_INFO *, DB **));
char *db_version __P((int *, int *, int *));
#if defined(__cplusplus)
};
#endif

/*******************************************************
 * Locking
 *******************************************************/
#define	DB_LOCKVERSION	1
#define	DB_LOCKMAGIC	0x090193

/* Flag values for lock_vec(). */
#define	DB_LOCK_NOWAIT		0x01	/* Don't wait on unavailable lock. */

/* Request types. */
typedef enum {
	DB_LOCK_DUMP,			/* Display held locks. */
	DB_LOCK_GET,			/* Get the lock. */
	DB_LOCK_PUT,			/* Release the lock. */
	DB_LOCK_PUT_ALL,		/* Release locker's locks. */
	DB_LOCK_PUT_OBJ			/* Release locker's locks on obj. */
} db_lockop_t;

/* Simple R/W lock modes and for multi-granularity intention locking. */
typedef enum {
	DB_LOCK_NG=0,			/* Not granted. */
	DB_LOCK_READ,			/* Shared/read. */
	DB_LOCK_WRITE,			/* Exclusive/write. */
	DB_LOCK_IREAD,			/* Intent to share/read. */
	DB_LOCK_IWRITE,			/* Intent exclusive/write. */
	DB_LOCK_IWR			/* Intent to read and write. */
} db_lockmode_t;

/* Lock request structure. */
struct __db_lockreq {
	db_lockop_t	 op;		/* Operation. */
	db_lockmode_t	 mode;		/* Requested mode. */
	u_int32_t	 locker;	/* Locker identity. */
	DBT		*obj;		/* Object being locked. */
	DB_LOCK		 lock;		/* Lock returned. */
};

/*
 * Commonly used conflict matrices.
 *
 * Standard Read/Write (or exclusive/shared) locks.
 */
#define	DB_LOCK_RW_N	3
extern const u_int8_t db_rw_conflicts[];

/* Multi-granularity locking. */
#define	DB_LOCK_RIW_N	6
extern const u_int8_t db_riw_conflicts[];

#if defined(__cplusplus)
extern "C" {
#endif
int	  lock_close __P((DB_LOCKTAB *));
int	  lock_get __P((DB_LOCKTAB *,
	    u_int32_t, int, const DBT *, db_lockmode_t, DB_LOCK *));
int	  lock_id __P((DB_LOCKTAB *, u_int32_t *));
int	  lock_open __P((const char *, int, int, DB_ENV *, DB_LOCKTAB **));
int	  lock_put __P((DB_LOCKTAB *, DB_LOCK));
int	  lock_unlink __P((const char *, int, DB_ENV *));
int	  lock_vec __P((DB_LOCKTAB *,
	    u_int32_t, int, DB_LOCKREQ *, int, DB_LOCKREQ **));
#if defined(__cplusplus)
};
#endif

/*******************************************************
 * Logging.
 *******************************************************/
#if defined(__cplusplus)
extern "C" {
#endif
int	 log_close __P((DB_LOG *));
int	 log_compare __P((const DB_LSN *, const DB_LSN *));
int	 log_file __P((DB_LOG *, const DB_LSN *, char **));
int	 log_flush __P((DB_LOG *, const DB_LSN *));
int	 log_get __P((DB_LOG *, DB_LSN *, DBT *, int));
int	 log_open __P((const char *, int, int, DB_ENV *, DB_LOG **));
int	 log_put __P((DB_LOG *, DB_LSN *, const DBT *, int));
int	 log_register __P((DB_LOG *, DB *, const char *, DBTYPE, u_int32_t *));
int	 log_unlink __P((const char *, int, DB_ENV *));
int	 log_unregister __P((DB_LOG *, u_int32_t));
#if defined(__cplusplus)
};
#endif

/*******************************************************
 * Mpool
 *******************************************************/
/* Flag values for memp_fget(). */
#define	DB_MPOOL_CREATE		0x001	/* Create a page. */
#define	DB_MPOOL_LAST		0x002	/* Return the last page. */
#define	DB_MPOOL_NEW		0x004	/* Create a new page. */

/* Flag values for memp_fput(), memp_fset(). */
#define	DB_MPOOL_CLEAN		0x001	/* Clear modified bit. */
#define	DB_MPOOL_DIRTY		0x002	/* Page is modified. */
#define	DB_MPOOL_DISCARD	0x004	/* Don't cache the page. */

/* Mpool statistics structure. */
struct __db_mpool_stat {
	size_t st_cachesize;		/* Cache size. */
	unsigned long st_cache_hit;	/* Pages found in the cache. */
	unsigned long st_cache_miss;	/* Pages not found in the cache. */
	unsigned long st_map;		/* Pages from mapped files. */
	unsigned long st_page_create;	/* Pages created in the cache. */
	unsigned long st_page_in;	/* Pages read in. */
	unsigned long st_page_out;	/* Pages written out. */
	unsigned long st_ro_evict;	/* Read-only pages evicted. */
	unsigned long st_rw_evict;	/* Read-write pages evicted. */
	unsigned long st_hash_buckets;	/* Number of hash buckets. */
	unsigned long st_hash_searches;	/* Total hash chain searches. */
	unsigned long st_hash_longest;	/* Longest hash chain searched. */
	unsigned long st_hash_examined;	/* Total hash entries searched. */
};

/* Mpool file statistics structure. */
struct __db_mpool_fstat {
	char *file_name;		/* File name. */
	size_t st_pagesize;		/* Page size. */
	unsigned long st_cache_hit;	/* Pages found in the cache. */
	unsigned long st_cache_miss;	/* Pages not found in the cache. */
	unsigned long st_map;		/* Pages from mapped files. */
	unsigned long st_page_create;	/* Pages created in the cache. */
	unsigned long st_page_in;	/* Pages read in. */
	unsigned long st_page_out;	/* Pages written out. */
};

#if defined(__cplusplus)
extern "C" {
#endif
int	memp_close __P((DB_MPOOL *));
int	memp_fclose __P((DB_MPOOLFILE *));
int	memp_fget __P((DB_MPOOLFILE *, db_pgno_t *, unsigned long, void *));
int	memp_fopen __P((DB_MPOOL *,
	    const char *, int, int, int, size_t, int, DBT *, DB_MPOOLFILE **));
int	memp_fput __P((DB_MPOOLFILE *, void *, unsigned long));
int	memp_fset __P((DB_MPOOLFILE *, void *, unsigned long));
int	memp_fsync __P((DB_MPOOLFILE *));
int	memp_open __P((const char *, int, int, DB_ENV *, DB_MPOOL **));
int	memp_register __P((DB_MPOOL *, int,
	    int (*)(db_pgno_t, void *, DBT *),
	    int (*)(db_pgno_t, void *, DBT *)));
int	memp_stat __P((DB_MPOOL *, DB_MPOOL_STAT **, DB_MPOOL_FSTAT ***));
int	memp_sync __P((DB_MPOOL *, DB_LSN *));
int	memp_unlink __P((const char *, int, DB_ENV *));
#if defined(__cplusplus)
};
#endif

/*******************************************************
 * Transactions.
 *******************************************************/
#define	DB_TXNVERSION	1
#define	DB_TXNMAGIC	0x041593

/* Operations values to the tx_recover() function. */
#define	DB_TXN_BACKWARD_ROLL	1	/* Read the log backwards. */
#define	DB_TXN_FORWARD_ROLL	2	/* Read the log forwards. */
#define	DB_TXN_OPENFILES	3	/* Read for open files. */
#define	DB_TXN_REDO		4	/* Redo the operation. */
#define	DB_TXN_UNDO		5	/* Undo the operation. */

#if defined(__cplusplus)
extern "C" {
#endif
int	  txn_abort __P((DB_TXN *));
int	  txn_begin __P((DB_TXNMGR *, DB_TXN *, DB_TXN **));
int	  txn_checkpoint __P((const DB_TXNMGR *, long, long));
int	  txn_commit __P((DB_TXN *));
int	  txn_close __P((DB_TXNMGR *));
u_int32_t txn_id __P((DB_TXN *));
int	  txn_open __P((const char *, int, int, DB_ENV *, DB_TXNMGR **));
int	  txn_prepare __P((DB_TXN *));
int	  txn_unlink __P((const char *, int, DB_ENV *));
#if defined(__cplusplus)
};
#endif

#ifdef DB_DBM_HSEARCH
/*******************************************************
 * Dbm/Ndbm historic interfaces.
 *******************************************************/
#define	DBM_INSERT	0		/* Flags to dbm_store(). */
#define	DBM_REPLACE	1

/*
 * The db(3) support for ndbm(3) always appends this suffix to the
 * file name to avoid overwriting the user's original database.
 */
#define	DBM_SUFFIX	".db"

typedef struct {
	char *dptr;
	int dsize;
} datum;

#if defined(__cplusplus)
extern "C" {
#endif
int	 dbminit __P((char *));
#if !defined(__cplusplus)
int	 delete __P((datum));
#endif
datum	 fetch __P((datum));
datum	 firstkey __P((void));
datum	 nextkey __P((datum));
int	 store __P((datum, datum));

/*
 * !!!
 * Don't prototype:
 *
 *	 dbm_clearerr(DBM *db);
 *	 dbm_dirfno(DBM *db);
 *	 dbm_error(DBM *db);
 *	 dbm_pagfno(DBM *db);
 *	 dbm_rdonly(DBM *db);
 *
 * they weren't documented and were historically implemented as #define's.
 */
void	 dbm_close __P((DBM *));
int	 dbm_delete __P((DBM *, datum));
datum	 dbm_fetch __P((DBM *, datum));
datum	 dbm_firstkey __P((DBM *));
long	 dbm_forder __P((DBM *, datum));
datum	 dbm_nextkey __P((DBM *));
DBM	*dbm_open __P((const char *, int, int));
int	 dbm_store __P((DBM *, datum, datum, int));
#if defined(__cplusplus)
};
#endif

/*******************************************************
 * Hsearch historic interface.
 *******************************************************/
typedef enum {
	FIND, ENTER
} ACTION;

typedef struct entry {
	char *key;
	void *data;
} ENTRY;

#if defined(__cplusplus)
extern "C" {
#endif
int	 hcreate __P((unsigned int));
void	 hdestroy __P((void));
ENTRY	*hsearch __P((ENTRY, ACTION));
#if defined(__cplusplus)
};
#endif
#endif /* DB_DBM_HSEARCH */

/*
 * XXX
 * MacOS: Reset Metrowerks C enum sizes.
 */
#ifdef __MWERKS__
#pragma enumsalwaysint reset
#endif
#endif /* !_DB_H_ */
