/* Copyright (c) 1997 QUALCOMM Incorporated.
 * All rights reserved.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <time.h>
#include <winsock.h>
#include <stdarg.h>

#include "ntport.h"

#include "lthread.h"
#include "portable.h"
#include "slap.h"
#include "ldapconfig.h"
#include "service.h"
#include "env.h"    //for CONFIG_INFO

extern void	daemon();
extern void	set_shutdown();
extern int	lber_debug;
extern char Versionstr[];

extern CONFIG_INFO gConfInfo;


#define TIMESIZE 126
int PrintTime = 1;
FILE *DebugFile = NULL;


void Debug( int level, char* fmt, ... )
{
	
	char timestr[TIMESIZE];
	va_list DbgArgs;
	int i = 0;
	time_t tp;
	struct tm *gmt;
	char fname[512];
		
	if( !(level & ldap_debug))
		return;

	if(!DebugFile)
	{
		//strcpy(fname, gConfInfo.LogDirectory);
		extern BOOL bDebug;
		
		if(time(&tp) == -1)
				return;
		gmt = gmtime(&tp);
		strftime(timestr, TIMESIZE, "%y%m%d", gmt);
		//strcat(fname, timestr);

		for(i=0; i < 999; i++)
		{
			if(bDebug == TRUE)
			{
				DebugFile = stderr;
				break;
			}
		
			sprintf(fname, "%sid%s.%3.3d", gConfInfo.LogDirectory, timestr, i);
			if( (DebugFile = fopen(fname, "r")) == NULL)
			{
				if( (DebugFile = fopen(fname, "w+")) == NULL)
					return;
				else 
					break;
			
			}
		}
	}
	if(!DebugFile)
		return;

	va_start( DbgArgs, fmt );

	if(PrintTime)
	{
		if(time(&tp) == -1)
				return;
		gmt = gmtime(&tp);
		strftime(timestr, TIMESIZE, "%Y%m%d  %H:%M:%S", gmt);
		fprintf(DebugFile, "%s\t", timestr);
	}
	
	vfprintf(DebugFile, fmt, DbgArgs);
	if(fmt[strlen(fmt)-1] == '\n')
		PrintTime = 1;
	else 
		PrintTime = 0;

	//reset the buffer
	va_end( DbgArgs );              /* Reset variable arguments. */

	//fflush(DebugFile);
}