/* Copyright (c) 1997 QUALCOMM Incorporated.
 * All rights reserved.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <time.h>
#include <winsock.h>
//#include <netinet/in.h>
//#include <arpa/inet.h>
//#include <netdb.h>
#include <stdarg.h>

#include "ntport.h"

#include "lthread.h"
#include "portable.h"
#include "slap.h"
#include "ldap.h"
#include "ldapconfig.h"
#include "service.h"
#include "env.h"    //for CONFIG_INFO

extern void	daemon();
extern void	set_shutdown();

extern char Versionstr[];

int InitConfigInfo();
extern CONFIG_INFO gConfInfo;


/*
 * read-only global variables or variables only written by the listener
 * thread (after they are initialized) - no need to protect them with a mutex.
 */

int             ldap_debug = LDAP_DEBUG_STATS;
#ifdef LDAP_DEBUG
int             ldap_syslog = LDAP_DEBUG_STATS;
#else
int             ldap_syslog;
#endif
int             ldap_syslog_level = 0; //LOG_DEBUG;



int			udp;
int			slapd_shutdown;
char		*default_referral;
//XXX
char		configfile[256];
time_t		starttime;
pthread_t	listener_tid;
int			g_argc;
char		**g_argv;
void		init();
void		read_config(char *, Backend **, FILE *);
/*
 * global variables that need mutex protection
 */
time_t			currenttime;
pthread_mutex_t	currenttime_mutex;
int				active_threads;
pthread_mutex_t	active_threads_mutex;
pthread_mutex_t	new_conn_mutex;
long			ops_initiated;
long			ops_completed;
int				num_conns;
pthread_mutex_t	ops_mutex;
long			num_entries_sent;
long			num_bytes_sent;
pthread_mutex_t	num_sent_mutex;


/*
 * these mutexes must be used when calling the entry2str()
 * routine since it returns a pointer to static data.
 */
pthread_mutex_t	entry2str_mutex;
pthread_mutex_t	replog_mutex;
#ifndef sunos5
pthread_mutex_t	regex_mutex;
#endif

#ifdef WIN32
VOID ServiceStart(DWORD argc, LPTSTR *argv)
#else
void main( int argc, char **argv )
#endif

{
	u_short		port;
	char		*myname;
	Backend		*be = NULL;
	FILE		*fp = NULL;
	extern char	*optarg;
	pthread_attr_t	attr;
	int		status;

	//configfile = SLAPD_DEFAULT_CONFIGFILE;
	//port = LDAP_PORT;
	g_argc = argc;
	g_argv = argv;

	///////////////////////////////////////////////////
    //
    // Service initialization
    //

    // report the status to the service control manager.
    //
    if (!ReportStatusToSCMgr(
        SERVICE_START_PENDING, // service state
        NO_ERROR,              // exit code
        3000))                 // wait hint
        goto cleanup;


	//ldap_debug = LDAP_DEBUG_CONNS;
	

	if ( (myname = strrchr( argv[0], '/' )) == NULL ) 
		myname = strdup( argv[0] );
	else 
		myname = strdup( myname + 1 );

	if( InitConfigInfo() != 0)
	{
		char buf[512];
		sprintf(buf, "Could not find config file in current directory %s", gConfInfo.WorkDir);
		AddToMessageLog(TEXT(buf));
		Debug( LDAP_DEBUG_ANY, "Could not find configuration file.\n");
		fflush(NULL);
		exit(1);
	}

	if( SetCurrentDirectory(gConfInfo.WorkDir) == 0)
	{
			Debug( LDAP_DEBUG_ANY, "Could not set current directory - %d.\n", GetLastError());
	}
	
	if( gConfInfo.Port > 0)
		port = gConfInfo.Port;
	else 
		port = LDAP_PORT;
	
	init();
	read_config( gConfInfo.ConfFile, &be, fp );
	ldap_debug = ldap_syslog;
	

	Debug( LDAP_DEBUG_TRACE, "%s", Versionstr, 0, 0 );	
	
    // report the status to the service control manager.
    //
    if (!ReportStatusToSCMgr(
        SERVICE_START_PENDING, // service state
        NO_ERROR,              // exit code
        3000))                 // wait hint
        goto cleanup;
	
	
	time( &starttime );
	pthread_attr_init( &attr );
	pthread_attr_setdetachstate( &attr, PTHREAD_CREATE_DETACHED );
	if ( pthread_create( &listener_tid, attr, (void *) daemon, (void *) port ) != 0 ) 
	{
			Debug( LDAP_DEBUG_ANY,"listener pthread_create failed\n", 0, 0, 0 );
			exit( 1 );
	}
	 // report the status to the service control manager.
    //
    if (!ReportStatusToSCMgr(
        SERVICE_RUNNING,       // service state
        NO_ERROR,              // exit code
        0))                    // wait hint
        goto cleanup;
	AddToMessageLog(TEXT("Eudora Directory Service Started"));
	
cleanup:
	pthread_attr_destroy( &attr );
	pthread_join( listener_tid, (void *) &status );
	
	ReportStatusToSCMgr(
        SERVICE_STOPPED,       // service state
        NO_ERROR,              // exit code
        0);                    // wait hint
    AddToMessageLog(TEXT("Eudora Directory Service Stopped"));
	pthread_exit( 0 );
}



void init()
{
	pthread_mutex_init( &active_threads_mutex, pthread_mutexattr_default );
	pthread_mutex_init( &new_conn_mutex, pthread_mutexattr_default );
	pthread_mutex_init( &currenttime_mutex, pthread_mutexattr_default );
	pthread_mutex_init( &entry2str_mutex, pthread_mutexattr_default );
	pthread_mutex_init( &replog_mutex, pthread_mutexattr_default );
	pthread_mutex_init( &ops_mutex, pthread_mutexattr_default );
	pthread_mutex_init( &num_sent_mutex, pthread_mutexattr_default );

	
#ifndef sunos5
	pthread_mutex_init( &regex_mutex, pthread_mutexattr_default );
#endif
}

VOID ServiceStop(){
	
	set_shutdown();
}

